module AST where
import PackedString(PackedString,packString)

data Color  = Red | Green | Blue | Cyan | Magenta | Yellow | Black | White
            | Undefined -- used to simplify equivalence test
            deriving (Eq, Show, Enum)

data Tag    = B | EM | I | PL | S | TT | U | Size !Int | Color !Color | STag STag
            deriving (Eq, Show)

type STag = [Tag]

data ADoc   = Text !Str
            | Tag !Tag Doc 
            | Space !Str
            deriving (Eq, Show)

type Doc    = [ADoc]

data Token = TText !Str
           | TTag !Tag
           | EndTag !Tag
           | TSpace !Str
           | TokEOF
           deriving (Eq, Show)

type Str = PackedString
--type Str = String
tSpace = TSpace . packString
tText = TText . packString
