module Context where
import AST(Color(..))

data PropertyRecord =
   PR { b,em,i,s,tt::Bool,
	u::Uscore,
	size::Size,
	color::Color }
   deriving (Eq,Show)

type Uscore = Int -- [0..3]
type Size = Int   -- [0..9]

spaceContext = resetb . resetcolor
  where
     resetb a = a { s=False,em=False,i=False,b=False }
     resetcolor a = if u a==0 then a { color=White } else a

p1 `spaceEq` p2 = spaceContext p1==spaceContext p2

rootContext =
  PR { b=False,
	 em=False,
	 i=False,
	 s=False,
	 tt=False,
	 u=0,
	 size= -1, -- anything is allowed
	 color=Undefined -- anything is allowed
       }
-- Testing in a context with "undefined" size & color is equivalent to
-- testing in all possible contexts, isn't it?

plainContext a = a{u=0,s=False,em=False,i=False,b=False,tt=False }
