module EMElimination(removeEM) where

import AST
import Parser
import SuperTag
import List ((\\))

removeDoubleEM :: Doc -> Doc
removeDoubleEM  = map removeDoubleEM'

removeDoubleEM' :: ADoc -> ADoc
removeDoubleEM' (Tag (STag ts) ds) =
  let ts' = clean ts
  in Tag (STag ts') (removeDoubleEM ds)
  where clean ts = 
          let ts1 = filter ((==) EM) ts
              ts2 = filter (not.((==) EM)) ts
              l = length ts1
          in if odd l
               then (EM:ts2)
               else ts2

removeDoubleEM' x = x


removeEM_ :: ADoc -> ADoc
removeEM_ (Tag (STag ts) d)
  | S `elem` ts =
      Tag (STag ts) d
  | (EM `elem` ts) && (manyEMs d') =
      Tag (STag (ts \\ [EM])) (map toggleEM d')
  | (EM `notElem` ts) && (moreEMs d') =
      Tag (STag (EM:ts)) (map toggleEM d')
  | otherwise = 
      Tag (STag ts) (removeEM' d)
  
  where d' = removeEM' d

        manyEMs d = let (a, b) = countEMs d
                    in a >= b
        
        moreEMs d = let (a, b) = countEMs d
                    in a >= b + 1

        countEMs [] = (0, 0)
        countEMs (d:ds)
          = let (a, b) = countEMs ds
            in case d of
                 Tag (STag ts) x
                   | S `elem` ts -> (a, b)
                   | PL `elem` ts -> (a, b)
                   | (EM `elem` ts) -> (a + 1, b)
                   | otherwise -> (a, b + 1)
                 _        -> (a, b + 1)

        toggleEM (Tag (STag ts) d) 
          | S `elem` ts = Tag (STag ts) d
          | PL `elem` ts = Tag (STag ts) d
          | EM `elem` ts = Tag (STag (ts \\ [EM])) d
          | otherwise = Tag (STag (EM:ts)) d
        toggleEM x = Tag (STag [EM]) [x]

removeEM_ x = x


removeEM' :: Doc -> Doc
removeEM' = map removeEM_


removeEM :: Doc -> Doc
removeEM = removeEmptySTag.removeEM'.dummyRoot.removeEmptySTag.removeDoubleEM.st


dummyRoot :: Doc -> Doc
dummyRoot d = [Tag (STag []) d]



