module RemoveSpace(removeSpace) where
import AST
import Context
import Meaning(start)

removeSpace = rmspace Nothing [rootContext]


rmspace prev ps [] = []
rmspace prev ps@(p:ps') (t:ts) =
  case t of
    --TText ""  -> rmspace prev ps ts -- (*)
    TText s   -> t:rmspace Nothing ps ts
    --TSpace "" -> rmspace prev ps ts -- (*)
    TSpace s  -> if tt p
		 then t:rmspace Nothing ps ts
		 else case prev of
			Just psp | psp==sp -> rmspace prev ps ts
		        _ -> oneSpace:rmspace (Just sp) ps ts
	where sp = spaceContext p
    TTag tag  -> t:rmspace prev (start tag p:ps) ts
    EndTag _  -> t:rmspace prev ps' ts


oneSpace = tSpace " "

{-
+ Invariant:
    The prev argument is
       Just sp, if the previous output character was a SPC
                with the space context sp, and
       Nothing, otherwise.

+ The lines marked with (*) can be included to make rmspace more rubust.
  Without these lines it assumes that the input is free from TText "" and
  TSpace "".
-}
