module SuperTag(st, stIntersect, removeEmptySTag) where

import AST
import Parser
import PPrint
import List ((\\))

st :: Doc -> Doc
st = map st_

st_ :: ADoc -> ADoc
st_ (Text s) = Tag (STag []) ([Text s])
st_ (Space s) = Tag (STag []) ([Text s])
st_ (Tag t [x]) =
  let Tag (STag ts) ds = st_ x
      STag ts' = mkSTag t
  in Tag (STag (ts' ++ ts)) ds
st_ (Tag t ds) = Tag (mkSTag t) (st ds)

mkSTag :: Tag -> Tag
mkSTag (STag ts) = STag ts
mkSTag x = STag [x]


stIntersect :: [Tag] -> [Tag] -> [Tag]
stIntersect x y =
  if (PL `elem` x && PL `elem` y)
  || ((not $ PL `elem` x) && (not $ PL `elem` y))
    then x `intersect` y
    else x `intersect` y \\ plSensitive
  where plSensitive = [B, I, U, TT, EM, S]


removeEmptySTag :: Doc -> Doc
removeEmptySTag = concat . (map removeEmptySTag_)

removeEmptySTag_ :: ADoc -> [ADoc]
removeEmptySTag_ (Tag (STag []) ds) = removeEmptySTag ds
removeEmptySTag_ x = [x]


-- bag intersection:
intersect []     ys = []
intersect (x:xs) ys
   | x `elem` ys    = x : intersect xs (ys \\ [x])
   | True           = intersect xs ys

